/**
 * Created by IntelliJ IDEA.
 * User: Kilho Shin
 * Date: 11/02/21
 * Time: 11:42
 * To change this template use File | Settings | File Templates.

 This file is part of Mapping Kernels for Trees.

 Mapping Kernels for Trees is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Mapping Kernels for Trees is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Mapping Kernels for Trees.  If not, see <http://www.gnu.org/licenses/>.

 For more details about this code, please look at the companion paper
 "Mapping Kernels for Trees", K. Shin, M.Cuturi, T.Kuboyama, Proceedings of
 the International Conference on Machine Learning 2011.

 */

import scala.actors._
import scala.actors.Actor._
//import scala.collection.mutable.Set

class CellCalculator(
  val mgr: DivCompManager,
  val krnList: List[(RefNode, RefNode)=>Bn]
//  exec: ((RefNode, RefNode)=>Bn, RefNode, RefNode)=>Bn
) extends Actor{

  var buffer: List[(((RefNode, RefNode)=>Bn, RefNode, RefNode), Bn)] = Nil

  def act {
    loop {
      react {
        case Calculate(x: (Int, Set[RefNode], Set[RefNode]),
                       y: (Int, Set[RefNode], Set[RefNode])) =>
          //println("******* Receive Clculate")
          buffer = Nil
          if(x._1 == y._1)
            for(i <- x._2; j <- y._2.dropWhile(i!=); k <- krnList)
              buffer ::= (k,i,j)->k(i,j)
          else if(x._1 < y._1)
            for(i <- x._2; j <- y._2; k <- krnList)
              buffer ::= (k,i,j)->k(i,j)
          for(i <- x._2; j <- y._3; k <- krnList)
            buffer ::= (k,i,j)->k(i,j)
          for(i <- x._3; j <- y._2; k <- krnList)
            buffer ::= (k,i,j)->k(i,j)
          for(i <- x._3; j <- y._3; k <- krnList)
            buffer ::= (k,i,j)->k(i,j)
          mgr ! Return(this, buffer)
        case Exit =>
          exit()
      }
    }
  }
}

