/**
 * Created by IntelliJ IDEA.
 * User: Kilho SHin
 * Date: 11/02/21
 * Time: 12:01
 * To change this template use File | Settings | File Templates.

  This file is part of Mapping Kernels for Trees.

  Mapping Kernels for Trees is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Mapping Kernels for Trees is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Mapping Kernels for Trees.  If not, see <http://www.gnu.org/licenses/>.

  For more details about this code, please look at the companion paper
  "Mapping Kernels for Trees", K. Shin, M.Cuturi, T.Kuboyama, Proceedings of
  the International Conference on Machine Learning 2011.

 */

class Vertex(val parent: Vertex, val label: String, val depth: Int) {
  var children: List[Vertex] = Nil
  var height: Int = 1
  var size: Int = 1
  var refAsTree: RefNode = null
  var refOfChildren: RefNode= null
  def this(l: String) = this(null, l, -1)
  def addChild(c: Vertex) = children ::= c
  def show(i : Int):Unit = {
    var pfx: String = ""
    for(j <- 1 to i) pfx += '>'
    println(pfx + "Label= " + label + ": Height=" + height)
    children.foreach(_.show(i+1))
  }
  def isIsomTo(v: Vertex): Boolean = {
    label == v.label &&
    children.length == v.children.length &&
    children.zip(v.children).foldLeft[Boolean](true)(
      (b, tpl) => b && (tpl._1.refAsTree == tpl._2.refAsTree)
    )
  }
}

